



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android应用程序启动过程（二）分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android应用程序启动过程（二）分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 05:43:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文依据Android6.0源码，从点击Launcher图标，直至解析到MainActivity#OnCreate()被调用。</p>
<h2>Launcher简析</h2>
<p>Launcher也是个应用程序，不过是个特殊的应用。俗称&ldquo;桌面&rdquo;。通过PackageManagerService查询所有已安装的应用程序，并保存相应的图标、应用名称、包名和第一个要启动的类名等。</p>
<p>源码位置：frameworks/base/core/java/android/app/LauncherActivity.java</p>
<p>LauncherActivity#onListItemClick()</p>
<div>
<div>
<pre class="prettyprint linenums">public abstract class LauncherActivity extends ListActivity {<br />
    @Override<br />
    protected void onListItemClick(ListView l, View v, int position, long id) {<br />
        Intent intent = intentForPosition(position);<br />
        startActivity(intent);<br />
    }<br />
}</pre>
</div>
</div>
<p>可以看到<code>LauncherActivity</code>继承自<code>ListActivity</code>，而<code>ListActivity</code>继承自<code>Activity</code>。在<code>LauncherActivity#onListItemClick()</code>方法中首先通过<code>intentForPosition()</code>获取了一个<code>Intent</code>，然后调用<code>startActivity(intent)</code>启动一个<code>Activity</code>。由于<code>ListActivity</code>并没有重写<code>Activity#startActivity()</code>方法，所以这里会直接调用<code>Activity#startActivity()</code>。在此之前先看下<code>intentForPosition()</code>是怎样构造<code>Intent</code>。</p>
<div>
<div>
<pre class="prettyprint linenums">protected Intent intentForPosition(int position) {<br />
        ActivityAdapter adapter = (ActivityAdapter) mAdapter;<br />
        return adapter.intentForPosition(position);<br />
    }

    private class ActivityAdapter extends BaseAdapter implements Filterable {<br />
        public Intent intentForPosition(int position) {<br />
            if (mActivitiesList == null) {<br />
                return null;<br />
            }<br />
            Intent intent = new Intent(mIntent);<br />
            ListItem item = mActivitiesList.get(position);<br />
            intent.setClassName(item.packageName, item.className);<br />
            if (item.extras != null) {<br />
                intent.putExtras(item.extras);<br />
            }<br />
            return intent;<br />
        }<br />
    }</pre>
</div>
</div>
<p><code>Intent</code>中只是指定了即将启动的<code>Activity</code>。</p>
<p>源码位置：frameworks/base/core/java/android/app/Activity.java</p>
<p>Activity#startActivity()</p>
<div>
<div>
<pre class="prettyprint linenums">public void startActivity(Intent intent) {<br />
    this.startActivity(intent, null);<br />
}

public void startActivity(Intent intent, @Nullable Bundle options) {<br />
    if (options != null) {<br />
        startActivityForResult(intent, -, options);<br />
    } else {<br />
        startActivityForResult(intent, -);<br />
    }<br />
}

/** @param requestCode If &gt;= 0, this code will be returned inonActivityResult() when the activity exits. */<br />
public void startActivityForResult(Intent intent, int requestCode) {<br />
    startActivityForResult(intent, requestCode, null);<br />
}

public void startActivityForResult(Intent intent, int requestCode, @Nullable Bundle options) {<br />
        Instrumentation.ActivityResult ar = mInstrumentation.execStartActivity(<br />
                this, mMainThread.getApplicationThread(), mToken, this,<br />
                intent, requestCode, options);<br />
       ...<br />
    }<br />
}</pre>
</div>
</div>
<p>在调用的过程中可以观察到，无论调用<code>StartActivity()</code>还是<code>startActivityForResult()</code>，最终调用的都是<code>startActivityForResult()</code>。而且注释说明只有<code>requestCode &gt;= 0</code>时<code>onActivityResult()</code>才会被调用。经过一系列的调用，最终调用了<code>Instrumentation#execStartActivity()</code>。跟进。</p>
<p>源码位置：frameworks/base/core/java/android/app/Instrumentation.java</p>
<p>Instrumentation#execStartActivity()</p>
<div>
<div>
<pre class="prettyprint linenums">public ActivityResult execStartActivity(<br />
    Context who, IBinder contextThread, IBinder token, Activity target,<br />
    Intent intent, int requestCode, Bundle options) {<br />
        ...<br />
        int result = ActivityManagerNative.getDefault()<br />
            .startActivity(whoThread, who.getBasePackageName(), intent,<br />
                    intent.resolveTypeIfNeeded(who.getContentResolver()),<br />
                    token, target != null ? target.mEmbeddedID : null,<br />
                    requestCode, , null, options);<br />
        ...<br />
}</pre>
</div>
</div>
<p>这里<code>ActivityManagerNative.getDefault()</code>涉及到Binder进程间通信机制。下面进行一个简短的介绍，这不是本文的重点。了解过同学的可以略过下面这段Binder简析，不想了解的也可以直接理解为返回的是<code>ActivityManagerService</code>（以下简称AMS）。实际调用的是<code>AMS#startActivity()</code></p>
<h2>AMS中Binder机制简析</h2>
<p>ActivityManagerNative.getDefault()</p>
<div>
<div>
<pre class="prettyprint linenums">static public IActivityManager getDefault() {<br />
    return gDefault.get();<br />
}

private static final Singleton&lt;IActivityManager&gt; gDefault = new Singleton&lt;IActivityManager&gt;() {<br />
    protected IActivityManager create() {<br />
        IBinder b = ServiceManager.getService("activity");<br />
        IActivityManager am = asInterface(b);<br />
        return am;<br />
    }<br />
};

static public IActivityManager asInterface(IBinder obj) {<br />
    if (obj == null) {<br />
        return null;<br />
    }<br />
    IActivityManager in =<br />
        (IActivityManager)obj.queryLocalInterface(descriptor);<br />
    if (in != null) {<br />
        return in;<br />
    }

    return new ActivityManagerProxy(obj);<br />
}</pre>
</div>
</div>
<p>本例中<code>AMS</code>作为服务器端，<code>ActivityManagerNative</code>作为客户端。在<code>getDefault()</code>方法中通过调用<code>asInterface()</code>方法中的&nbsp;<code>new ActivityManagerProxy(obj)</code>返回了<code>IActivityManager</code>的子类对象<code>AMS</code>。从哪里可以看出来呢？这个就比较难找了，不过细心点还是可以发现写蛛丝马迹。重点在于<code>IBinder b = ServiceManager.getService("activity")</code>，这里的参数是&ldquo;activity&rdquo;。在上篇博文<a href="http://blog.csdn.net/qq_17250009/article/details/52143652" rel="external nofollow noreferrer">SystemServer启动流程源码解析</a>中，分析<code>SystemServer#startBootstrapServices()</code>方法启动AMS之后调用<code>mActivityManagerService.setSystemProcess()</code>，跟进。</p>
<p>源码位置：frameworks/base/services/java/com/android/server/SystemServer.java</p>
<p>SystemServer#startBootstrapServices()</p>
<div>
<div>
<pre class="prettyprint linenums">private void startBootstrapServices() {<br />
    Installer installer = mSystemServiceManager.startService(Installer.class);

    // Activity manager runs the show.<br />
    mActivityManagerService = mSystemServiceManager.startService(<br />
            ActivityManagerService.Lifecycle.class).getService();<br />
    mActivityManagerService.setSystemServiceManager(mSystemServiceManager);<br />
    mActivityManagerService.setInstaller(installer);<br />
    // Set up the Application instance for the system process and get started.<br />
    mActivityManagerService.setSystemProcess();<br />
}

public void setSystemProcess() {<br />
    ServiceManager.addService(Context.ACTIVITY_SERVICE, this, true);<br />
}</pre>
</div>
</div>
<p>静态常量<code>Context.ACTIVITY_SERVICE = "activity"</code>。到这里就对上了。先<code>addService("activity")</code>，然后<code>getService("activity")</code>。其实在add和get的时候，又是一次通过Binder进行进程间通信的过程。这次和本文关系不大，这里不再拓展。下面回到<code>AMS#startActivity()</code></p>
<h2>调用过程解析</h2>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityManagerService.java</p>
<p>ActivityManagerService#startActivity()</p>
<div>
<div>
<pre class="prettyprint linenums"> @Override<br />
public final int startActivity(IApplicationThread caller, String callingPackage,<br />
        Intent intent, String resolvedType, IBinder resultTo, String resultWho, int requestCode,<br />
        int startFlags, ProfilerInfo profilerInfo, Bundle options) {<br />
    return startActivityAsUser(caller, callingPackage, intent, resolvedType, resultTo,<br />
        resultWho, requestCode, startFlags, profilerInfo, options,<br />
        UserHandle.getCallingUserId());<br />
}

@Override<br />
public final int startActivityAsUser(IApplicationThread caller, String callingPackage,<br />
        Intent intent, String resolvedType, IBinder resultTo, String resultWho, int requestCode,<br />
        int startFlags, ProfilerInfo profilerInfo, Bundle options, int userId) {<br />
    // 验证CallingUid是否合法<br />
    enforceNotIsolatedCaller("startActivity");<br />
    // 检查限权<br />
    userId = handleIncomingUser(Binder.getCallingPid(), Binder.getCallingUid(), userId,<br />
            false, ALLOW_FULL_ONLY, "startActivity", null);<br />
    return mStackSupervisor.startActivityMayWait(caller, -, callingPackage, intent,<br />
            resolvedType, null, null, resultTo, resultWho, requestCode, startFlags,<br />
            profilerInfo, null, null, options, false, userId, null, null);<br />
}</pre>
</div>
</div>
<p>简单验证后开始调用<code>StackSupervisor#startActivityMayWait()</code>，跟进。&nbsp;<br />源码位置：frameworks/base/services/core/java/com/android/server/am/StackSupervisor.java</p>
<p>StackSupervisor#startActivityMayWait()、StackSupervisor#resolveActivity()</p>
<div>
<div>
<pre class="prettyprint linenums">final int startActivityMayWait(IApplicationThread caller, int callingUid,<br />
                               String callingPackage, Intent intent, String resolvedType,<br />
                               IVoiceInteractionSession voiceSession, IVoiceInteractor voiceInteractor,<br />
                               IBinder resultTo, String resultWho, int requestCode, int startFlags,<br />
                               ProfilerInfo profilerInfo, WaitResult outResult, Configuration config,<br />
                               Bundle options, boolean ignoreTargetSecurity, int userId,<br />
                               IActivityContainer iContainer, TaskRecord inTask) {<br />
      ...<br />
     // 解析intent信息<br />
     ActivityInfo aInfo = resolveActivity(intent, resolvedType, startFlags, profilerInfo, userId);<br />
     // 验证pid uid(省略)<br />
     ...<br />
    int res = startActivityLocked(caller, intent, resolvedType, aInfo,<br />
            voiceSession, voiceInteractor, resultTo, resultWho,<br />
            requestCode, callingPid, callingUid, callingPackage,<br />
            realCallingPid, realCallingUid, startFlags, options, ignoreTargetSecurity,<br />
            componentSpecified, null, container, inTask);

    return res;<br />
}

ActivityInfo resolveActivity(Intent intent, String resolvedType, int startFlags,<br />
                             ProfilerInfo profilerInfo, int userId) {<br />
    // Collect information about the target of the Intent.<br />
    ActivityInfo aInfo;<br />
    try {<br />
        ResolveInfo rInfo = AppGlobals.getPackageManager().resolveIntent(<br />
                        intent, resolvedType,<br />
                        PackageManager.MATCH_DEFAULT_ONLY<br />
                        | ActivityManagerService.STOCK_PM_FLAGS, userId);<br />
        aInfo = rInfo != null ? rInfo.activityInfo : null;<br />
    } catch (RemoteException e) {<br />
        aInfo = null;<br />
    }

    if (aInfo != null) {<br />
        intent.setComponent(new ComponentName(aInfo.applicationInfo.packageName, aInfo.name));<br />
        ...<br />
    }<br />
    return aInfo;<br />
}</pre>
</div>
</div>
<p>在调用<code>resolveActivity()</code>之后会读取配置文件中包名和要启动<code>Activity</code>完整的路径名，并分别赋值给aInfo.applicationInfo.packageName和aInfo.name。跟进。</p>
<p>StackSupervisor#startActivityLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final int startActivityLocked(IApplicationThread caller,<br />
                              Intent intent, String resolvedType, ActivityInfo aInfo,<br />
                              IVoiceInteractionSession voiceSession, IVoiceInteractor voiceInteractor,<br />
                              IBinder resultTo, String resultWho, int requestCode,<br />
                              int callingPid, int callingUid, String callingPackage,<br />
                              int realCallingPid, int realCallingUid, int startFlags, Bundle options,<br />
                              boolean ignoreTargetSecurity, boolean componentSpecified, ActivityRecord[] outActivity,<br />
                              ActivityContainer container, TaskRecord inTask) {<br />
    ProcessRecord callerApp = null;<br />
    if (caller != null) {<br />
        callerApp = mService.getRecordForAppLocked(caller);<br />
        if (callerApp != null) {<br />
            callingPid = callerApp.pid;<br />
            callingUid = callerApp.info.uid;<br />
        } else {<br />
            err = ActivityManager.START_PERMISSION_DENIED;<br />
        }<br />
    }<br />
    ...<br />
    ActivityRecord r = new ActivityRecord(mService, callerApp, callingUid, callingPackage,<br />
            intent, resolvedType, aInfo, mService.mConfiguration, resultRecord, resultWho,<br />
            requestCode, componentSpecified, voiceSession != null, this, container, options);<br />
    // 检查intent中的flag信息<br />
    ...<br />
    // 检查限权<br />
    ...<br />
    ...<br />
    err = startActivityUncheckedLocked(r, sourceRecord, voiceSession, voiceInteractor,<br />
            startFlags, true, options, inTask);<br />
    return err;

}</pre>
</div>
</div>
<p>这个方法近300行代码，我们只看关键的部分就好了。首先获取调用者的pid、uid等信息，然后保存在<code>callerApp</code>中。目标<code>Activity</code>的信息保存在 r 中。跟进。</p>
<p>StackSupervisor#startActivityUncheckedLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final int startActivityUncheckedLocked(final ActivityRecord r, ActivityRecord sourceRecord,<br />
    IVoiceInteractionSession voiceSession, IVoiceInteractor voiceInteractor, int startFlags,<br />
    boolean doResume, Bundle options, TaskRecord inTask) {<br />
    ...<br />
    int launchFlags = intent.getFlags();<br />
    // 对intent的flag各种判断<br />
    ...<br />
    ActivityRecord notTop = (launchFlags &amp; Intent.FLAG_ACTIVITY_PREVIOUS_IS_TOP) !=  ? r : null;<br />
    ...<br />
            ActivityStack sourceStack;<br />
    if (sourceRecord != null) {<br />
        if (sourceRecord.finishing) {<br />
            if ((launchFlags &amp; Intent.FLAG_ACTIVITY_NEW_TASK) == ) {<br />
                Slog.w(TAG, "startActivity called from finishing " + sourceRecord<br />
                        + "; forcing " + "Intent.FLAG_ACTIVITY_NEW_TASK for: " + intent);<br />
                launchFlags |= Intent.FLAG_ACTIVITY_NEW_TASK;<br />
                newTaskInfo = sourceRecord.info;<br />
                newTaskIntent = sourceRecord.task.intent;<br />
            }<br />
            sourceRecord = null;<br />
            sourceStack = null;<br />
        } else {<br />
            sourceStack = sourceRecord.task.stack;<br />
        }<br />
    } else {<br />
        sourceStack = null;<br />
    }<br />
    ...<br />
    if (((launchFlags &amp; Intent.FLAG_ACTIVITY_NEW_TASK) !=  &amp;&amp;<br />
            (launchFlags &amp; Intent.FLAG_ACTIVITY_MULTIPLE_TASK) == )<br />
            || launchSingleInstance || launchSingleTask) {<br />
        if (inTask == null &amp;&amp; r.resultTo == null) {<br />
            // See if there is a task to bring to the front.  If this is<br />
            // a SINGLE_INSTANCE activity, there can be one and only one<br />
            // instance of it in the history, and it is always in its own<br />
            // unique task, so we do a special search.<br />
            ActivityRecord intentActivity = !launchSingleInstance ?<br />
                    findTaskLocked(r) : findActivityLocked(intent, r.info);<br />
    ...<br />
    }<br />
    ...<br />
    // Should this be considered a new task?<br />
    if (r.resultTo == null &amp;&amp; inTask == null &amp;&amp; !addingToTask<br />
            &amp;&amp; (launchFlags &amp; Intent.FLAG_ACTIVITY_NEW_TASK) != ) {<br />
        newTask = true;<br />
        targetStack = computeStackFocus(r, newTask);<br />
        targetStack.moveToFront("startingNewTask");

        if (reuseTask == null) {<br />
            // 设任务栈<br />
            r.setTask(targetStack.createTaskRecord(getNextTaskId(),<br />
                    newTaskInfo != null ? newTaskInfo : r.info,<br />
                    newTaskIntent != null ? newTaskIntent : intent,<br />
                    voiceSession, voiceInteractor, !launchTaskBehind /* toTop */),<br />
                    taskToAffiliate);<br />
        }<br />
        ...<br />
    }<br />
    ...<br />
    targetStack.startActivityLocked(r, newTask, doResume, keepCurTransition, options);<br />
    return ActivityManager.START_SUCCESS;<br />
}</pre>
</div>
</div>
<p>这个方法600+行，而且好多逻辑判断，看的几近崩溃。不过还好，关键的代码已经被过滤出来了～首先确定几个变量。前面都没有设置过<code>intent</code>的<code>flag</code>，所以<code>launchFlags = 0x00000000</code>，但是在执行<code>launchFlags |= Intent.FLAG_ACTIVITY_NEW_TASK</code>之后。<code>launchFlags = Intent.FLAG_ACTIVITY_NEW_TASK</code>。<code>notTop = null</code>。由于没有要接收返回信息的<code>Activity</code>，所以<code>r.resultTo == null</code>。由于没有设置<code>Activity</code>的启动模式为<code>SingleInstance</code>，所以<code>launchSingleInstance = false</code>，即会执行<code>findTaskLocked(r)</code>。这个方法的作用是查找历史所有<code>stack</code>中有没有目标<code>Activity</code>，很显然返回值为<code>null</code>，所以下面很大一段判断逻辑都不会执行。大约200行，爽～。既然没有相应的任务栈，肯定要创建的。在上文中创建任务栈对应的方法为<code>targetStack.createTaskRecord()</code>。最后执行<code>ActivityStack#startActivityLocked()</code>，跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityStack.java</p>
<p>ActivityStack#startActivityLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final void startActivityLocked(ActivityRecord r, boolean newTask,<br />
        boolean doResume, boolean keepCurTransition, Bundle options) {<br />
    ...<br />
    // newTask = true<br />
    if(!newTask){<br />
        ...<br />
    }<br />
    task = r.task;<br />
    // 将ActivityRecord置于栈顶<br />
    task.addActivityToTop(r);<br />
    // 将任务栈置于前台<br />
    task.setFrontOfTask();<br />
    ...<br />
    if (doResume) {<br />
        mStackSupervisor.resumeTopActivitiesLocked(this, r, options);<br />
    }<br />
}</pre>
</div>
</div>
<p>跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/StackSupervisor.java</p>
<p>StackSupervisor#resumeTopActivitiesLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">boolean resumeTopActivitiesLocked(ActivityStack targetStack, ActivityRecord target,<br />
                                  Bundle targetOptions) {<br />
    if (targetStack == null) {<br />
        targetStack = mFocusedStack;<br />
    }<br />
    // Do targetStack first.<br />
    boolean result = false;<br />
    if (isFrontStack(targetStack)) {<br />
        result = targetStack.resumeTopActivityLocked(target, targetOptions);<br />
    }

    for (int displayNdx = mActivityDisplays.size() - ; displayNdx &gt;= ; --displayNdx) {<br />
        final ArrayList&lt;ActivityStack&gt; stacks = mActivityDisplays.valueAt(displayNdx).mStacks;<br />
        for (int stackNdx = stacks.size() - ; stackNdx &gt;= ; --stackNdx) {<br />
            final ActivityStack stack = stacks.get(stackNdx);<br />
            if (stack == targetStack) {<br />
                // Already started above.<br />
                continue;<br />
            }<br />
            if (isFrontStack(stack)) {<br />
                stack.resumeTopActivityLocked(null);<br />
            }<br />
        }<br />
    }<br />
    return result;<br />
}</pre>
</div>
</div>
<p>这个方法的作用是将<code>Launcher</code>应用程序所在的任务栈执行<code>resumeTopActivityLocked()</code>方法。跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityStack.java</p>
<p>ActivityStack#resumeTopActivityLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final boolean resumeTopActivityLocked(ActivityRecord prev, Bundle options) {<br />
    if (mStackSupervisor.inResumeTopActivity) {<br />
        // Don't even start recursing.<br />
        return false;<br />
    }

    boolean result = false;<br />
    try {<br />
        // Protect against recursion.<br />
        mStackSupervisor.inResumeTopActivity = true;<br />
        if (mService.mLockScreenShown == ActivityManagerService.LOCK_SCREEN_LEAVING) {<br />
            mService.mLockScreenShown = ActivityManagerService.LOCK_SCREEN_HIDDEN;<br />
            mService.updateSleepIfNeededLocked();<br />
        }<br />
        result = resumeTopActivityInnerLocked(prev, options);<br />
    } finally {<br />
        mStackSupervisor.inResumeTopActivity = false;<br />
    }<br />
    return result;<br />
}</pre>
</div>
</div>
<p>跟进。</p>
<p>ActivityStack#resumeTopActivityInnerLocked()</p>
<div>
<div>
<pre class="prettyprint linenums"> private boolean resumeTopActivityInnerLocked(ActivityRecord prev, Bundle options) {<br />
    ...<br />
    // If the top activity is the resumed one, nothing to do.<br />
    if (mResumedActivity == next &amp;&amp; next.state == ActivityState.RESUMED &amp;&amp;<br />
                mStackSupervisor.allResumedActivitiesComplete()) {<br />
        ...<br />
        return false;<br />
    }<br />
    ...<br />
    if (mResumedActivity != null) {<br />
        if (DEBUG_STATES) Slog.d(TAG_STATES,<br />
                "resumeTopActivityLocked: Pausing " + mResumedActivity);<br />
        pausing |= startPausingLocked(userLeaving, false, true, dontWaitForPause);<br />
    }<br />
    ...<br />
    mStackSupervisor.startSpecificActivityLocked(next, true, true);<br />
    ...<br />
}</pre>
</div>
</div>
<p>这个方法的主要作用是将<code>mResumedActivity</code>暂停(<code>Launcher</code>任务栈的<code>TopActivity</code>)，即进入<code>onPause</code>状态。之后启动指定的<code>AttivityRecored</code>，即<code>target AttivityRecored</code>。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityStackSupervisor.java</p>
<p>ActivityStackSupervisor#startSpecificActivityLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">void startSpecificActivityLocked(ActivityRecord r, boolean andResume, boolean checkConfig) {<br />
    // Is this activity's application already running?<br />
    ProcessRecord app = mService.getProcessRecordLocked(r.processName,<br />
            r.info.applicationInfo.uid, true);

    r.task.stack.setLaunchTime(r);

    if (app != null &amp;&amp; app.thread != null) {<br />
        try {<br />
            if ((r.info.flags &amp; ActivityInfo.FLAG_MULTIPROCESS) ==<br />
                    || !"android".equals(r.info.packageName)) {<br />
                // Don't add this if it is a platform component that is marked<br />
                // to run in multiple processes, because this is actually<br />
                // part of the framework so doesn't make sense to track as a<br />
                // separate apk in the process.<br />
                app.addPackage(r.info.packageName, r.info.applicationInfo.versionCode,<br />
                        mService.mProcessStats);<br />
            }<br />
            realStartActivityLocked(r, app, andResume, checkConfig);<br />
            return;<br />
        } catch (RemoteException e) {<br />
            Slog.w(TAG, "Exception when starting activity "<br />
                    + r.intent.getComponent().flattenToShortString(), e);<br />
        }

        // If a dead object exception was thrown -- fall through to<br />
        // restart the application.<br />
    }

    mService.startProcessLocked(r.processName, r.info.applicationInfo, true, ,<br />
            "activity", r.intent.getComponent(), false, false, true);<br />
}</pre>
</div>
</div>
<p>由于没有在指定<code>Application</code>的<code>process</code>属性，所以这里的<code>app = null</code>。</p>
<p>详见<code>ActivityStackSupervisor#getProcessRecordLocked()</code>。</p>
<div>
<div>
<pre class="prettyprint linenums">final ProcessRecord getProcessRecordLocked(String processName, int uid, boolean keepIfLarge) {<br />
    if (uid == Process.SYSTEM_UID) {<br />
        // The system gets to run in any process.  If there are multiple<br />
        // processes with the same uid, just pick the first (this<br />
        // should never happen).<br />
        SparseArray&lt;ProcessRecord&gt; procs = mProcessNames.getMap().get(processName);<br />
        if (procs == null) return null;<br />
        ...<br />
    }<br />
    ...<br />
}</pre>
</div>
</div>
<p>跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityManagerService.java</p>
<p>ActivityManagerService#startProcessLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final ProcessRecord startProcessLocked(String processName,<br />
        ApplicationInfo info, boolean knownToBeDead, int intentFlags,<br />
        String hostingType, ComponentName hostingName, boolean allowWhileBooting,<br />
        boolean isolated, boolean keepIfLarge) {<br />
    return startProcessLocked(processName, info, knownToBeDead, intentFlags, hostingType,<br />
            hostingName, allowWhileBooting, isolated,  /* isolatedUid */, keepIfLarge,<br />
            null /* ABI override */, null /* entryPoint */, null /* entryPointArgs */,<br />
            null /* crashHandler */);<br />
}</pre>
</div>
</div>
<p>跟进。</p>
<p>ActivityManagerService#startProcessLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">final ProcessRecord startProcessLocked(String processName, ApplicationInfo info,<br />
            boolean knownToBeDead, int intentFlags, String hostingType, ComponentName hostingName,<br />
        boolean allowWhileBooting, boolean isolated, int isolatedUid, boolean keepIfLarge,<br />
        String abiOverride, String entryPoint, String[] entryPointArgs, Runnable crashHandler) {<br />
    // isolated = false<br />
    if (!isolated) {<br />
        // 没有指定application的process，所以app = null<br />
        app = getProcessRecordLocked(processName, info.uid, keepIfLarge);<br />
        ...<br />
    }<br />
    ...<br />
    if (app == null) {<br />
        checkTime(startTime, "startProcess: creating new process record");<br />
        // 创建ProcessRecord<br />
        app = newProcessRecordLocked(info, processName, isolated, isolatedUid);<br />
        ...<br />
        checkTime(startTime, "startProcess: done creating new process record");<br />
    }<br />
}<br />
    ...<br />
    checkTime(startTime, "startProcess: stepping in to startProcess");<br />
    // hostingNameStr="activity" 后面仨参数都是null<br />
    startProcessLocked(<br />
            app, hostingType, hostingNameStr, abiOverride, entryPoint, entryPointArgs);<br />
    checkTime(startTime, "startProcess: done starting proc!");</pre>
</div>
</div>
<p>终于看见<code>Process</code>的身影了，亲人呐！！！</p>
<p>ActivityManagerService#startProcessLocked()</p>
<div>
<div>
<pre class="prettyprint linenums">private final void startProcessLocked(ProcessRecord app, String hostingType,<br />
        String hostingNameStr, String abiOverride, String entryPoint, String[] entryPointArgs) {<br />
        ...<br />
    try {<br />
        int uid = app.uid;<br />
        int[] gids = null;<br />
        int mountExternal = Zygote.MOUNT_EXTERNAL_NONE;<br />
        // isolated = false<br />
        if (!app.isolated) {<br />
            int[] permGids = null;<br />
            try {<br />
                checkTime(startTime, "startProcess: getting gids from package manager");<br />
                final IPackageManager pm = AppGlobals.getPackageManager();<br />
                permGids = pm.getPackageGids(app.info.packageName, app.userId);<br />
                MountServiceInternal mountServiceInternal = LocalServices.getService(<br />
                        MountServiceInternal.class);<br />
                mountExternal = mountServiceInternal.getExternalStorageMountMode(uid,<br />
                        app.info.packageName);<br />
            } catch (RemoteException e) {<br />
                throw e.rethrowAsRuntimeException();<br />
            }

            /*<br />
             * Add shared application and profile GIDs so applications can share some<br />
             * resources like shared libraries and access user-wide resources<br />
             */<br />
            if (ArrayUtils.isEmpty(permGids)) {<br />
                gids = new int[];<br />
            } else {<br />
                gids = new int[permGids.length + ];<br />
                System.arraycopy(permGids, , gids, , permGids.length);<br />
            }<br />
            gids[] = UserHandle.getSharedAppGid(UserHandle.getAppId(uid));<br />
            gids[] = UserHandle.getUserGid(UserHandle.getUserId(uid));<br />
        }<br />
        ...<br />
        String requiredAbi = (abiOverride != null) ? abiOverride : app.info.primaryCpuAbi;<br />
        if (requiredAbi == null) {<br />
            requiredAbi = Build.SUPPORTED_ABIS[];<br />
        }

        String instructionSet = null;<br />
        if (app.info.primaryCpuAbi != null) {<br />
            instructionSet = VMRuntime.getInstructionSet(app.info.primaryCpuAbi);<br />
        }

        app.gids = gids;<br />
        app.requiredAbi = requiredAbi;<br />
        app.instructionSet = instructionSet;

        checkTime(startTime, "startProcess: asking zygote to start proc");<br />
        Process.ProcessStartResult startResult = Process.start(entryPoint,<br />
                app.processName, uid, uid, gids, debugFlags, mountExternal,<br />
                app.info.targetSdkVersion, app.info.seinfo, requiredAbi, instructionSet,<br />
                app.info.dataDir, entryPointArgs);<br />
        checkTime(startTime, "startProcess: returned from zygote!");<br />
        ...<br />
    }<br />
    ...<br />
}</pre>
</div>
</div>
<p>这个方法太重要了，所以展示的代码稍微多一些。首先确定几个参数值。<code>hostingType = activity</code>、后面的三个参数<code>abiOverride</code>、<code>entryPoint</code>和<code>entryPointArgs</code>均等于<code>null</code>、<code>app.isolated = false</code>。首先创建了<code>gids[]</code>这个参数，然后在前两项插入<code>AppGid</code>和<code>UserGid</code>，然后构造了<code>requiredAbi</code>、<code>instructionSet</code>等参数，之后调用<code>Process#start()</code>来创建新进程。<code>Process#start()</code>。现在是凌晨两点，如果你像我一样已经写了5个小时，一定会发现这方法名字是多么的让人陶醉～</p>
<p>跟进。</p>
<p>源码位置：frameworks/base/core/java/android/os/Process.java</p>
<div>
<div>
<pre class="prettyprint linenums">public static final ProcessStartResult start(final String processClass,<br />
                              final String niceName,<br />
                              int uid, int gid, int[] gids,<br />
                              int debugFlags, int mountExternal,<br />
                              int targetSdkVersion,<br />
                              String seInfo,<br />
                              String abi,<br />
                              String instructionSet,<br />
                              String appDataDir,<br />
                              String[] zygoteArgs) {<br />
    try {<br />
        return startViaZygote(processClass, niceName, uid, gid, gids,<br />
                debugFlags, mountExternal, targetSdkVersion, seInfo,<br />
                abi, instructionSet, appDataDir, zygoteArgs);<br />
    } catch (ZygoteStartFailedEx ex) {<br />
        Log.e(LOG_TAG,<br />
                "Starting VM process through Zygote failed");<br />
        throw new RuntimeException(<br />
                "Starting VM process through Zygote failed", ex);<br />
    }<br />
}</pre>
</div>
</div>
<p>这是只是调用<code>startViaZygote()</code>进一步处理。跟进。</p>
<p>Process#startViaZygote()</p>
<div>
<div>
<pre class="prettyprint linenums">private static ProcessStartResult startViaZygote(final String processClass,<br />
                              final String niceName,<br />
                              final int uid, final int gid,<br />
                              final int[] gids,<br />
                              int debugFlags, int mountExternal,<br />
                              int targetSdkVersion,<br />
                              String seInfo,<br />
                              String abi,<br />
                              String instructionSet,<br />
                              String appDataDir,<br />
                              String[] extraArgs)<br />
                              throws ZygoteStartFailedEx {<br />
    synchronized(Process.class) {<br />
        ArrayList&lt;String&gt; argsForZygote = new ArrayList&lt;String&gt;();

        // --runtime-args, --setuid=, --setgid=,<br />
        // and --setgroups= must go first<br />
        argsForZygote.add("--runtime-args");<br />
        argsForZygote.add("--setuid=" + uid);<br />
        argsForZygote.add("--setgid=" + gid);<br />
        ...<br />
                    // --setgroups is a comma-separated list<br />
        if (gids != null &amp;&amp; gids.length &gt; ) {<br />
            StringBuilder sb = new StringBuilder();<br />
            sb.append("--setgroups=");

            int sz = gids.length;<br />
            for (int i = ; i &lt; sz; i++) {<br />
                if (i != ) {<br />
                    sb.append(',');<br />
                }<br />
                sb.append(gids[i]);<br />
            }

            argsForZygote.add(sb.toString());<br />
        }

        if (niceName != null) {<br />
            argsForZygote.add("--nice-name=" + niceName);<br />
        }

        if (seInfo != null) {<br />
            argsForZygote.add("--seinfo=" + seInfo);<br />
        }

        if (instructionSet != null) {<br />
            argsForZygote.add("--instruction-set=" + instructionSet);<br />
        }

        if (appDataDir != null) {<br />
            argsForZygote.add("--app-data-dir=" + appDataDir);<br />
        }

        argsForZygote.add(processClass);

        if (extraArgs != null) {<br />
            for (String arg : extraArgs) {<br />
                argsForZygote.add(arg);<br />
            }<br />
        }<br />
        return zygoteSendArgsAndGetResult(openZygoteSocketIfNeeded(abi), argsForZygote);<br />
    }<br />
}</pre>
</div>
</div>
<p>可以看到，这里前面一大段都在构造参数<code>argsForZygote</code>，<code>uid</code>啦、<code>gid</code>啦、<code>-nice-name</code>啦，这里需要注意<code>processClass = android.app.ActivityThread</code>，后文会用到。参数构造完成之后，接下来看下<code>openZygoteSocketIfNeeded()</code>这个方法。</p>
<p>Process#openZygoteSocketIfNeeded()</p>
<div>
<div>
<pre class="prettyprint linenums">/**<br />
 * Tries to open socket to Zygote process if not already open. If<br />
 * already open, does nothing.  May block and retry.<br />
 */<br />
private static ZygoteState openZygoteSocketIfNeeded(String abi) throws ZygoteStartFailedEx {<br />
    if (primaryZygoteState == null || primaryZygoteState.isClosed()) {<br />
        try {<br />
            primaryZygoteState = ZygoteState.connect(ZYGOTE_SOCKET);<br />
        } catch (IOException ioe) {<br />
            throw new ZygoteStartFailedEx("Error connecting to primary zygote", ioe);<br />
        }<br />
    }

    if (primaryZygoteState.matches(abi)) {<br />
        return primaryZygoteState;<br />
    }

    // The primary zygote didn't match. Try the secondary.<br />
    if (secondaryZygoteState == null || secondaryZygoteState.isClosed()) {<br />
        try {<br />
        secondaryZygoteState = ZygoteState.connect(SECONDARY_ZYGOTE_SOCKET);<br />
        } catch (IOException ioe) {<br />
            throw new ZygoteStartFailedEx("Error connecting to secondary zygote", ioe);<br />
        }<br />
    }

    if (secondaryZygoteState.matches(abi)) {<br />
        return secondaryZygoteState;<br />
    }

    throw new ZygoteStartFailedEx("Unsupported zygote ABI: " + abi);<br />
}</pre>
</div>
</div>
<p>罕见的我把注释写上了，因为注释说的比我清楚～接下来跟进<code>zygoteSendArgsAndGetResult()</code>方法。</p>
<p>Process#zygoteSendArgsAndGetResult()</p>
<div>
<div>
<pre class="prettyprint linenums">/**<br />
 * Sends an argument list to the zygote process, which starts a new child<br />
 * and returns the child's pid. Please note: the present implementation<br />
 * replaces newlines in the argument list with spaces.<br />
 *<br />
 * @throws ZygoteStartFailedEx if process start failed for any reason<br />
 */<br />
private static ProcessStartResult zygoteSendArgsAndGetResult(<br />
        ZygoteState zygoteState, ArrayList&lt;String&gt; args)<br />
        throws ZygoteStartFailedEx {<br />
    try {<br />
        /**<br />
         * See com.android.internal.os.ZygoteInit.readArgumentList()<br />
         * Presently the wire format to the zygote process is:<br />
         * a) a count of arguments (argc, in essence)<br />
         * b) a number of newline-separated argument strings equal to count<br />
         *<br />
         * After the zygote process reads these it will write the pid of<br />
         * the child or -1 on failure, followed by boolean to<br />
         * indicate whether a wrapper process was used.<br />
         */<br />
        final BufferedWriter writer = zygoteState.writer;<br />
        final DataInputStream inputStream = zygoteState.inputStream;

        writer.write(Integer.toString(args.size()));<br />
        writer.newLine();

        int sz = args.size();<br />
        for (int i = ; i &lt; sz; i++) {<br />
            String arg = args.get(i);<br />
            if (arg.indexOf('\n') &gt;= ) {<br />
                throw new ZygoteStartFailedEx(<br />
                        "embedded newlines not allowed");<br />
            }<br />
            writer.write(arg);<br />
            writer.newLine();<br />
        }

        writer.flush();

        // Should there be a timeout on this?<br />
        ProcessStartResult result = new ProcessStartResult();<br />
        result.pid = inputStream.readInt();<br />
        if (result.pid &lt; ) {<br />
            throw new ZygoteStartFailedEx("fork() failed");<br />
        }<br />
        result.usingWrapper = inputStream.readBoolean();<br />
        return result;<br />
    } catch (IOException ex) {<br />
        zygoteState.close();<br />
        throw new ZygoteStartFailedEx(ex);<br />
    }<br />
}</pre>
</div>
</div>
<p>注释也说的很清楚，给<code>Zygote</code>发送一个<code>argument list</code>。通知<code>Zygote</code>进程启动一个子进程。再接下来就该和<code>Zygote</code>进程打交道了。</p>
<p>太晚了，关键明天还要上班。明天再细致分析这部分，古耐～</p>
<h2>大哥大Zygote</h2>
<p>在另一篇博文<a href="http://blog.csdn.net/qq_17250009/article/details/52061171" rel="external nofollow noreferrer">Android Zygote启动流程源码解析</a>中说到：在<code>Zygote#main()</code>中先注册了一个<code>serverSocket</code>，在启动了<code>SystemServer</code>进程之后，一直监听这个<code>serverSocket</code>，准备启动新的应用进程。大概过程如下：</p>
<p>源码位置：frameworks/base/core/java/com/android/internal/os/ZygoteInit.java</p>
<p>ZygoteInit#main()</p>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String argv[]) {<br />
    // 注册socket<br />
    registerZygoteSocket(socketName);<br />
    ...<br />
    if (startSystemServer) {<br />
        // 启动SystemServer进程<br />
        startSystemServer(abiList, socketName);<br />
    }<br />
    // 监听socket,启动新的应用进程。--后文会讲<br />
    runSelectLoop(abiList);<br />
    closeServerSocket();<br />
    ...<br />
}</pre>
</div>
</div>
<p>跟进<code>runSelectLoop(abiList)</code>。</p>
<p>ZygoteInit#runSelectLoop()</p>
<div>
<div>
<pre class="prettyprint linenums"> private static void runSelectLoop(String abiList) throws MethodAndArgsCaller {<br />
    while (true) {<br />
        int index;<br />
        ...<br />
        if (index &lt; ) {<br />
            throw new RuntimeException("Error in select()");<br />
        } else if (index == ) {<br />
            ZygoteConnection newPeer = acceptCommandPeer(abiList);<br />
            peers.add(newPeer);<br />
            fds.add(newPeer.getFileDescriptor());<br />
        } else {<br />
            boolean done;<br />
            done = peers.get(index).runOnce();

            if (done) {<br />
                peers.remove(index);<br />
                fds.remove(index);<br />
            }<br />
        }<br />
    }<br />
}

private static ZygoteConnection acceptCommandPeer(String abiList) {<br />
    try {<br />
        return new ZygoteConnection(sServerSocket.accept(), abiList);<br />
    } catch (IOException ex) {<br />
        ...<br />
    }<br />
}</pre>
</div>
</div>
<p>这个方法的主要作用是通过<code>acceptCommandPeer()</code>方法接收客户端发送的<code>Socket</code>消息。之后执行<code>ZygoteConnection#runOnce()</code>方法。跟进。</p>
<p>源码位置：frameworks/base/core/java/com/android/internal/os/ZygoteConnection.java</p>
<p>ZygoteConnection#runOnce()</p>
<div>
<div>
<pre class="prettyprint linenums">boolean runOnce() throws ZygoteInit.MethodAndArgsCaller {<br />
    ...<br />
    checkTime(startTime, "zygoteConnection.runOnce: preForkAndSpecialize");<br />
    pid = Zygote.forkAndSpecialize(parsedArgs.uid, parsedArgs.gid, parsedArgs.gids,<br />
                parsedArgs.debugFlags, rlimits, parsedArgs.mountExternal, parsedArgs.seInfo,<br />
                parsedArgs.niceName, fdsToClose, parsedArgs.instructionSet,<br />
                parsedArgs.appDataDir);<br />
    checkTime(startTime, "zygoteConnection.runOnce: postForkAndSpecialize");<br />
    ...<br />
    if (pid == ) {<br />
        // in child<br />
        IoUtils.closeQuietly(serverPipeFd);<br />
        serverPipeFd = null;<br />
        handleChildProc(parsedArgs, descriptors, childPipeFd, newStderr);<br />
            // should never get here, the child is expected to either<br />
            // throw ZygoteInit.MethodAndArgsCaller or exec().<br />
            return true;<br />
        } else {<br />
           ...<br />
        }<br />
        ...<br />
}</pre>
</div>
</div>
<p>省略的一大段代码都在构造参数，之后根据参数调用Zygote.forkAndSpecialize()方法fork出应用程序进程，到这里，应用进程已经被创建了。因为是子进程pid = 0，所以之后会调用handleChildProc()方法进一步处理。跟进。</p>
<p>ZygoteConnection#handleChildProc()</p>
<div>
<div>
<pre class="prettyprint linenums">private void handleChildProc(Arguments parsedArgs,<br />
        FileDescriptor[] descriptors, FileDescriptor pipeFd, PrintStream newStderr)<br />
        throws ZygoteInit.MethodAndArgsCaller {<br />
    closeSocket();<br />
    ZygoteInit.closeServerSocket();<br />
    ...<br />
    ZygoteInit.invokeStaticMain(cloader, className, mainArgs);<br />
    ...<br />
}   </pre>
</div>
</div>
<p>上述代码先关闭从<code>Zygote</code>进程继承来的<code>ServerSocket</code>，然后调用<code>ZygoteInit.invokeStaticMain()</code>。接下来的流程和启动System进程流程差不多，这里快速的过一遍。</p>
<p>源码位置：frameworks/base/core/java/com/android/internal/os/ZygoteInit.java</p>
<p>ZygoteInit#invokeStaticMain()</p>
<div>
<div>
<pre class="prettyprint linenums">static void invokeStaticMain(ClassLoader loader, String className, String[] argv)<br />
        throws ZygoteInit.MethodAndArgsCaller {<br />
    Class&lt;?&gt; cl;<br />
    try {<br />
        cl = loader.loadClass(className);<br />
    } catch (ClassNotFoundException ex) {<br />
        throw new RuntimeException(<br />
                "Missing class when invoking static main " + className, ex);<br />
    }<br />
    Method m;<br />
    m = cl.getMethod("main", new Class[] { String[].class });<br />
    int modifiers = m.getModifiers();<br />
    if (! (Modifier.isStatic(modifiers) &amp;&amp; Modifier.isPublic(modifiers))) {<br />
        throw new RuntimeException(<br />
                "Main method is not public and static on " + className);<br />
    }<br />
    throw new ZygoteInit.MethodAndArgsCaller(m, argv);<br />
}</pre>
</div>
</div>
<p>意料之中的装载类文件、意料之中的反射、意料之中的验证修饰符、意料之中的抛出个异常，甚至意料之中的在<code>Zygote#main()</code>中捕获。看过<a href="http://blog.csdn.net/qq_17250009/article/details/52061171" rel="external nofollow noreferrer">Zygote启动流程源码解析</a>的读着肯定和我有一样的感觉。接下来就该捕获异常，然后反射<code>ActivityThread</code>的静态方法<code>main()</code>。直接贴代码了，so boring&hellip;</p>
<p>ZygoteInit#main()</p>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String argv[]) {<br />
    try {<br />
        ...<br />
        runSelectLoop(abiList);<br />
    } catch (MethodAndArgsCaller caller) {<br />
        caller.run();<br />
    }

    // ZygoteInit&amp;MethodAndArgsCaller#run()<br />
    public void run() {<br />
        try {<br />
            mMethod.invoke(null, new Object[] { mArgs });<br />
        } catch (IllegalAccessException ex) {<br />
            ...<br />
        }<br />
    }</pre>
</div>
</div>
<p>这里反射调用的是<code>ActivityThread#main()</code>方法。跟进。</p>
<h2>主进程的创建流程</h2>
<p>源码位置：frameworks/base/core/java/com/android/app/ActivityThread.java</p>
<p>ActivityThread#main()</p>
<div>
<div>
<pre class="prettyprint linenums"> public static void main(String[] args) {<br />
    Trace.traceBegin(Trace.TRACE_TAG_ACTIVITY_MANAGER, "ActivityThreadMain");<br />
    SamplingProfilerIntegration.start();<br />
    ...<br />
    Looper.prepareMainLooper();<br />
    ActivityThread thread = new ActivityThread();<br />
    thread.attach(false);

    if (sMainThreadHandler == null) {<br />
        sMainThreadHandler = thread.getHandler();<br />
    }<br />
    Looper.loop();<br />
    throw new RuntimeException("Main thread loop unexpectedly exited");<br />
}</pre>
</div>
</div>
<p>我们知道ActivityThread就是所谓的主线程，其实ActivityThread并不是一个主线程。只是一个拥有mainLooper的入口方法。</p>
<p>概述中说：在Android系统中，启动四大组件中的任何一个都可以启动应用程序。启动四大组件的都可以启动应用程序，但实际上入口方法只有ActivityThread#main()一个(未验证）。</p>
<p>在做了一些初始化的工作后，调用了ActivityThread#attach(false)。跟进。</p>
<div>
<div>
<pre class="prettyprint linenums">final ApplicationThread mAppThread = new ApplicationThread();

private void attach(boolean system) {<br />
    sCurrentActivityThread = this;<br />
    mSystemThread = system;<br />
    if (!system) {<br />
        ...<br />
        final IActivityManager mgr = ActivityManagerNative.getDefault();<br />
        try {<br />
            mgr.attachApplication(mAppThread);<br />
        } catch (RemoteException ex) {<br />
            // Ignore<br />
        }<br />
        ...<br />
    }<br />
    ...<br />
}</pre>
</div>
</div>
<p>前文<code>AMS中的Binder机制</code>中分析过：<code>ActivityManagerNative.getDefault()</code>，返回的是<code>AMS</code>。其中跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityManagerService.java</p>
<p>ActivityManagerService#attachApplication()</p>
<div>
<div>
<pre class="prettyprint linenums">public final void attachApplication(IApplicationThread thread) {<br />
    synchronized (this) {<br />
        int callingPid = Binder.getCallingPid();<br />
        final long origId = Binder.clearCallingIdentity();<br />
        attachApplicationLocked(thread, callingPid);<br />
        Binder.restoreCallingIdentity(origId);<br />
    }<br />
}</pre>
</div>
</div>
<p>这里只是调用两个参数的<code>attachApplicationLocked()</code>方法处理。跟进。</p>
<div>
<div>
<pre class="prettyprint linenums">private final boolean attachApplicationLocked(IApplicationThread thread,int pid) {<br />
    ...<br />
    if (normalMode) {<br />
        try {<br />
            if (mStackSupervisor.attachApplicationLocked(app)) {<br />
                didSomething = true;<br />
            }<br />
        } catch (Exception e) {<br />
            Slog.wtf(TAG, "Exception thrown launching activities in " + app, e);<br />
            badApp = true;<br />
        }<br />
    }<br />
    ...<br />
}</pre>
</div>
</div>
<p>跟进。</p>
<p>源码位置：frameworks/base/services/core/java/com/android/server/am/ActivityStackSupervisor.java</p>
<p>ActivityStackSupervisor#attachApplicationLocked()</p>
<div>
<div>
<pre class="prettyprint linenums"> boolean attachApplicationLocked(ProcessRecord app) throws RemoteException {<br />
    final String processName = app.processName;<br />
    boolean didSomething = false;<br />
    for (int displayNdx = mActivityDisplays.size() - ; displayNdx &gt;= ; --displayNdx) {<br />
        ArrayList&lt;ActivityStack&gt; stacks = mActivityDisplays.valueAt(displayNdx).mStacks;<br />
        for (int stackNdx = stacks.size() - ; stackNdx &gt;= ; --stackNdx) {<br />
            final ActivityStack stack = stacks.get(stackNdx);<br />
            if (!isFrontStack(stack)) {<br />
                continue;<br />
            }<br />
            ActivityRecord hr = stack.topRunningActivityLocked(null);<br />
            if (hr != null) {<br />
                if (hr.app == null &amp;&amp; app.uid == hr.info.applicationInfo.uid<br />
                        &amp;&amp; processName.equals(hr.processName)) {<br />
                    try {<br />
                        if (realStartActivityLocked(hr, app, true, true)) {<br />
                            didSomething = true;<br />
                        }<br />
                    } catch (RemoteException e) {<br />
                        ...<br />
                    }<br />
                }<br />
            }<br />
        }<br />
    }<br />
    ...<br />
    return didSomething;<br />
}</pre>
</div>
</div>
<p>首先遍历所有<code>stack</code>，之后找到目前被置于前台的<code>stack</code>。之后通过<code>topRunningActivityLocked()</code>获取最上面的<code>Activity</code>。最后调用<code>realStartActivityLocked()</code>方法来真正的启动目标<code>Activity</code>。跟进</p>
<p>源码位置：frameworks/base/services/java/com/android/server/am/ActivityStack.java</p>
<p>ActivityStack#realStartActivityLocked()</p>
<div>
<div>
<pre class="prettyprint linenums"> final boolean realStartActivityLocked(ActivityRecord r,<br />
        ProcessRecord app, boolean andResume, boolean checkConfig)<br />
        throws RemoteException {<br />
    ...<br />
                app.thread.scheduleLaunchActivity(new Intent(r.intent), r.appToken,<br />
                System.identityHashCode(r), r.info, new Configuration(mService.mConfiguration),<br />
                r.compat, r.launchedFromPackage, r.task.voiceInteractor, app.repProcState,<br />
                r.icicle, r.persistentState, results, newIntents, !andResume,<br />
                mService.isNextTransitionForward(), profilerInfo);<br />
}<br />
...</pre>
</div>
</div>
<p>这里通过<code>Binder</code>，会调用<code>ApplicationThread#scheduleLaunchActivity()</code>。跟进。</p>
<p>源码位置：frameworks/base/core/java/android/app/ActivityThread.java</p>
<p>ActivityThread&amp;ApplicationThread#scheduleLaunchActivity()</p>
<div>
<div>
<pre class="prettyprint linenums"> public final void scheduleLaunchActivity(Intent intent, IBinder token, int ident,<br />
        ActivityInfo info, Configuration curConfig, Configuration overrideConfig,<br />
        CompatibilityInfo compatInfo, String referrer, IVoiceInteractor voiceInteractor,<br />
        int procState, Bundle state, PersistableBundle persistentState,<br />
        List&lt;ResultInfo&gt; pendingResults, List&lt;ReferrerIntent&gt; pendingNewIntents,<br />
        boolean notResumed, boolean isForward, ProfilerInfo profilerInfo) {

    updateProcessState(procState, false);<br />
    ActivityClientRecord r = new ActivityClientRecord();<br />
    r.token = token;<br />
    r.ident = ident;<br />
    r.intent = intent;<br />
    r.referrer = referrer;<br />
    r.voiceInteractor = voiceInteractor;<br />
    r.activityInfo = info;<br />
    r.compatInfo = compatInfo;<br />
    r.state = state;<br />
    ...<br />
    sendMessage(H.LAUNCH_ACTIVITY, r);<br />
}</pre>
</div>
</div>
<p>构造一个<code>ActivityClientRecord</code>对象之后，调用<code>sendMessage(H.LAUNCH_ACTIVITY, r)</code>。跟进。</p>
<div>
<div>
<pre class="prettyprint linenums">private void sendMessage(int what, Object obj) {<br />
    sendMessage(what, obj, , , false);<br />
}

private void sendMessage(int what, Object obj, int arg1, int arg2, boolean async) {<br />
    if (DEBUG_MESSAGES) Slog.v(<br />
        TAG, "SCHEDULE " + what + " " + mH.codeToString(what)<br />
        + ": " + arg1 + " / " + obj);<br />
    Message msg = Message.obtain();<br />
    msg.what = what;<br />
    msg.obj = obj;<br />
    msg.arg1 = arg1;<br />
    msg.arg2 = arg2;<br />
    if (async) {<br />
        msg.setAsynchronous(true);<br />
    }<br />
    mH.sendMessage(msg);<br />
}</pre>
</div>
</div>
<p>根据参数组装了一个<code>Message</code>对象，之后通过<code>mH.sendMessage(msg)</code>发送出去。看下<code>mH</code>是个什么鬼。跟进。</p>
<p>ActivityThread、ActivityThread&amp;H</p>
<div>
<div>
<pre class="prettyprint linenums">public final class ActivityThread {<br />
    ...<br />
    final H mH = new H();<br />
    ...<br />
        private class H extends Handler {<br />
        public static final int LAUNCH_ACTIVITY         = ;<br />
        public static final int PAUSE_ACTIVITY          = ;<br />
        ...<br />
        public void handleMessage(Message msg) {<br />
            switch (msg.what) {<br />
                case LAUNCH_ACTIVITY: {<br />
                    Trace.traceBegin(Trace.TRACE_TAG_ACTIVITY_MANAGER, "activityStart");<br />
                    final ActivityClientRecord r = (ActivityClientRecord) msg.obj;

                    r.packageInfo = getPackageInfoNoCheck(<br />
                            r.activityInfo.applicationInfo, r.compatInfo);<br />
                    handleLaunchActivity(r, null);<br />
                    Trace.traceEnd(Trace.TRACE_TAG_ACTIVITY_MANAGER);<br />
                } break;<br />
                ...<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>原来<code>mH</code>不过是Handler的子类罢了。接着在<code>handleMessage()</code>中解析出<code>Message</code>对象，然后调用<code>handleLaunchActivity()</code>进一步处理。跟进。</p>
<p>ActivityThread#handleLaunchActivity()</p>
<div>
<div>
<pre class="prettyprint linenums"> private final void handleLaunchActivity(ActivityClientRecord r, Intent customIntent) {<br />
    ......<br />
    // 加载activity,然后调用onCreate,onStart方法<br />
    Activity a = performLaunchActivity(r, customIntent);<br />
    if (a != null) {<br />
        // 调用onResume方法<br />
        handleResumeActivity(r.token, false, r.isForward,<br />
                !r.activity.mFinished &amp;&amp; !r.startsNotResumed);<br />
        ...<br />
    }<br />
    ...<br />
}  </pre>
</div>
</div>
<p>这是个蛮重要的方法。<a href="http://blog.csdn.net/qq_17250009/article/details/52816169" rel="external nofollow noreferrer">Activity启动流程源码解析</a>里有详细讲解，这里暂时略过。&nbsp;<br />跟进。</p>
<p>ActivityThread#performLaunchActivity()</p>
<div>
<div>
<pre class="prettyprint linenums"> private Activity performLaunchActivity(ActivityClientRecord r, Intent customIntent) {<br />
        // System.out.println("##### [" + System.currentTimeMillis() + "] ActivityThread.performLaunchActivity(" + r + ")");

        ActivityInfo aInfo = r.activityInfo;<br />
        if (r.packageInfo == null) {<br />
            r.packageInfo = getPackageInfo(aInfo.applicationInfo, r.compatInfo,<br />
                    Context.CONTEXT_INCLUDE_CODE);<br />
        }

        ComponentName component = r.intent.getComponent();<br />
        if (component == null) {<br />
            component = r.intent.resolveActivity(<br />
                mInitialApplication.getPackageManager());<br />
            r.intent.setComponent(component);<br />
        }

        if (r.activityInfo.targetActivity != null) {<br />
            component = new ComponentName(r.activityInfo.packageName,<br />
                    r.activityInfo.targetActivity);<br />
        }

        Activity activity = null;<br />
        try {<br />
            java.lang.ClassLoader cl = r.packageInfo.getClassLoader();<br />
            activity = mInstrumentation.newActivity(<br />
                    cl, component.getClassName(), r.intent);<br />
            StrictMode.incrementExpectedActivityCount(activity.getClass());<br />
            r.intent.setExtrasClassLoader(cl);<br />
            r.intent.prepareToEnterProcess();<br />
            if (r.state != null) {<br />
                r.state.setClassLoader(cl);<br />
            }<br />
        } catch (Exception e) {<br />
            if (!mInstrumentation.onException(activity, e)) {<br />
                throw new RuntimeException(<br />
                    "Unable to instantiate activity " + component<br />
                    + ": " + e.toString(), e);<br />
            }<br />
        }

        try {<br />
            Application app = r.packageInfo.makeApplication(false, mInstrumentation);

            if (localLOGV) Slog.v(TAG, "Performing launch of " + r);<br />
            if (localLOGV) Slog.v(<br />
                    TAG, r + ": app=" + app<br />
                    + ", appName=" + app.getPackageName()<br />
                    + ", pkg=" + r.packageInfo.getPackageName()<br />
                    + ", comp=" + r.intent.getComponent().toShortString()<br />
                    + ", dir=" + r.packageInfo.getAppDir());

            if (activity != null) {<br />
                Context appContext = createBaseContextForActivity(r, activity);<br />
                CharSequence title = r.activityInfo.loadLabel(appContext.getPackageManager());<br />
                Configuration config = new Configuration(mCompatConfiguration);<br />
                if (DEBUG_CONFIGURATION) Slog.v(TAG, "Launching activity "<br />
                        + r.activityInfo.name + " with config " + config);<br />
                activity.attach(appContext, this, getInstrumentation(), r.token,<br />
                        r.ident, app, r.intent, r.activityInfo, title, r.parent,<br />
                        r.embeddedID, r.lastNonConfigurationInstances, config,<br />
                        r.referrer, r.voiceInteractor);

                if (customIntent != null) {<br />
                    activity.mIntent = customIntent;<br />
                }<br />
                r.lastNonConfigurationInstances = null;<br />
                activity.mStartedActivity = false;<br />
                int theme = r.activityInfo.getThemeResource();<br />
                if (theme != ) {<br />
                    activity.setTheme(theme);<br />
                }

                activity.mCalled = false;<br />
                if (r.isPersistable()) {<br />
                    mInstrumentation.callActivityOnCreate(activity, r.state, r.persistentState);<br />
                } else {<br />
                    mInstrumentation.callActivityOnCreate(activity, r.state);<br />
                }<br />
                if (!activity.mCalled) {<br />
                    throw new SuperNotCalledException(<br />
                        "Activity " + r.intent.getComponent().toShortString() +<br />
                        " did not call through to super.onCreate()");<br />
                }<br />
                r.activity = activity;<br />
                r.stopped = true;<br />
                if (!r.activity.mFinished) {<br />
                    activity.performStart();<br />
                    r.stopped = false;<br />
                }<br />
                if (!r.activity.mFinished) {<br />
                    if (r.isPersistable()) {<br />
                        if (r.state != null || r.persistentState != null) {<br />
                            mInstrumentation.callActivityOnRestoreInstanceState(activity, r.state,<br />
                                    r.persistentState);<br />
                        }<br />
                    } else if (r.state != null) {<br />
                        mInstrumentation.callActivityOnRestoreInstanceState(activity, r.state);<br />
                    }<br />
                }<br />
                if (!r.activity.mFinished) {<br />
                    activity.mCalled = false;<br />
                    if (r.isPersistable()) {<br />
                        mInstrumentation.callActivityOnPostCreate(activity, r.state,<br />
                                r.persistentState);<br />
                    } else {<br />
                        mInstrumentation.callActivityOnPostCreate(activity, r.state);<br />
                    }<br />
                    if (!activity.mCalled) {<br />
                        throw new SuperNotCalledException(<br />
                            "Activity " + r.intent.getComponent().toShortString() +<br />
                            " did not call through to super.onPostCreate()");<br />
                    }<br />
                }<br />
            }<br />
            r.paused = true;

            mActivities.put(r.token, r);

        } catch (SuperNotCalledException e) {<br />
            throw e;

        } catch (Exception e) {<br />
            if (!mInstrumentation.onException(activity, e)) {<br />
                throw new RuntimeException(<br />
                    "Unable to start activity " + component<br />
                    + ": " + e.toString(), e);<br />
            }<br />
        }

        return activity;<br />
    }</pre>
</div>
</div>
<p>因为这个方法比较重要，所以代码完整的贴出来了。可以看到，首先收集要启动的<code>Activity</code>信息。然后通过<code>ClassLoader</code>加载目标<code>Activiy</code>类。再然后创建<code>Application</code>，最后调用<code>Activity#onCreate()</code>。内容有些多，我们一步步的看。先从创建<code>Application</code>说起。<code>r.packageInfo</code>是<code>LoadedApk</code>对象，所以会调用<code>LoadedApk#makeApplication()</code>。</p>
<p>源码位置：frameworks/base/core/java/android/app/LoadedApk.java</p>
<p>LoadedApk#makeApplication()</p>
<div>
<div>
<pre class="prettyprint linenums">public Application makeApplication(boolean forceDefaultAppClass,<br />
        Instrumentation instrumentation) {<br />
    if (mApplication != null) {<br />
        return mApplication;<br />
    }

    Application app = null;<br />
    ...<br />
    try {<br />
        ContextImpl appContext = ContextImpl.createAppContext(mActivityThread, this);<br />
        app = mActivityThread.mInstrumentation.newApplication(<br />
                cl, appClass, appContext);<br />
    } catch (Exception e) {<br />
        ...<br />
    }<br />
    ...<br />
    if (instrumentation != null) {<br />
        try {<br />
            instrumentation.callApplicationOnCreate(app);<br />
        } catch (Exception e) {<br />
            ...<br />
            }<br />
        }<br />
    }<br />
    return app;<br />
}</pre>
</div>
</div>
<p>方法名称已经很明显了。跟进。</p>
<p>源码位置：frameworks/base/core/java/android/app/Instrumentation.java</p>
<p>Instrumentation#newApplication()</p>
<div>
<div>
<pre class="prettyprint linenums"> public Application newApplication(ClassLoader cl, String className, Context context)<br />
        throws InstantiationException, IllegalAccessException,<br />
        ClassNotFoundException {<br />
    return newApplication(cl.loadClass(className), context);<br />
}

static public Application newApplication(Class&lt;?&gt; clazz, Context context)<br />
        throws InstantiationException, IllegalAccessException,<br />
        ClassNotFoundException {<br />
    Application app = (Application)clazz.newInstance();<br />
    app.attach(context);<br />
    return app;<br />
}</pre>
</div>
</div>
<p>简单粗暴，通过反射创建一个<code>Application</code>实例。现在实例有了，但<code>onCreate()</code>方法还没有被调用。跟进<code>Instrumentation#callApplicationOnCreate()</code></p>
<div>
<div>
<pre class="prettyprint linenums">public void callApplicationOnCreate(Application app) {<br />
    app.onCreate();<br />
}</pre>
</div>
</div>
<p>这都没法解析了，，直接调用<code>Application#onCreate()</code>。现在已经有了<code>Application</code>，但<code>Activity</code>只是被<code>ClassLoader</code>装载了，<code>onCreate()</code>还没有调起来。回到<code>ActivityThread#performLaunchActivity()</code></p>
<div>
<div>
<pre class="prettyprint linenums">...<br />
activity.attach(appContext, this, getInstrumentation(), r.token,<br />
                r.ident, app, r.intent, r.activityInfo, title, r.parent,<br />
                r.embeddedID, r.lastNonConfigurationInstances, config,<br />
                r.referrer, r.voiceInteractor);

mInstrumentation.callActivityOnCreate(activity, r.state, r.persistentState);<br />
...</pre>
</div>
</div>
<p>跟进。</p>
<p>源码位置：frameworks/base/core/java/android/app/callActivityOnCreate.java</p>
<p>Instrumentation#callActivityOnCreate()</p>
<div>
<div>
<pre class="prettyprint linenums">public void callActivityOnCreate(Activity activity, Bundle icicle,<br />
        PersistableBundle persistentState) {<br />
    prePerformCreate(activity);<br />
    activity.performCreate(icicle, persistentState);<br />
    postPerformCreate(activity);<br />
}

// Activity#performCreate()<br />
final void performCreate(Bundle icicle) {<br />
    onCreate(icicle);<br />
    mActivityTransitionState.readState(icicle);<br />
    performCreateCommon();<br />
}</pre>
</div>
</div>
<p>在<code>Activity#performCreate()</code>这里调用了<code>OnCreate()</code>方法。终于把我们的应用程序启动起来了~</p>
<h2>总结</h2>
<h3>总体流程</h3>
<ol><li>Launcher通过Binder机制通知AMS启动一个Activity</li>
<li>AMS使Launcher栈最顶端Activity进入onPause状态</li>
<li>AMS通知Process使用Socket和Zygote进程通信，请求创建一个新进程</li>
<li>Zygote收到Socket请求，fork出一个进程，并调用ActivityThread#main()</li>
<li>ActivityThread通过Binder通知AMS启动应用程序</li>
<li>AMS通知ActivityStackSupervisor真正的启动Activity</li>
<li>ActivityStackSupervisor通知ApplicationThread启动Activity</li>
<li>ApplicationThread发消息给ActivityThread，需要启动一个Activity</li>
<li>ActivityThread收到消息之后，通知LoadedApk创建Applicaition，并且调用其onCteate()方法</li>
<li>ActivityThread装载目标Activity类，并调用Activity#attach()</li>
<li>ActivityThread通知Instrumentation调用Activity#onCreate()</li>
<li>Instrumentation调用Activity#performCreate()，在Activity#performCreate()中调用自身onCreate()方法</li></ol>
<h3>第一次启动应用程序，Application和Activity#onCreate()方法调用顺序</h3>
<ol><li>装载Activity</li>
<li>装载Application</li>
<li>Application#attach()</li>
<li>Application#onCreate()</li>
<li>Activity#attach()</li>
<li>Activity#onCreate()</li></ol>
<p><a href="https://blog.csdn.net/qq_17250009/article/details/52204918" rel="external nofollow noreferrer">https://blog.csdn.net/qq_17250009/article/details/52204918</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390mxpm8.html">brew管理node的版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pp4g79.html">微信内嵌html5页面清楚缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qne6djq.html">C&plus;&plus;之路进阶&mdash;&mdash;codevs1362（网络扩容）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojgvv9.html">C&plus;&plus;11的一些新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vvr0o8.html">jQuery 中的children&lpar;&rpar;和 find&lpar;&rpar; 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv2z7jq.html">php接二进制文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xj0rw9.html">&lbrack;转&rsqb;Git介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1exnd9.html">MAC虚拟机NAT方式共享上网设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv44myq.html">解决一个maven在eclipse中M2&lowbar;HOME不能调整的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1mzr9.html">Android 保存用户偏好设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjopo8.html">thinkphp学习笔记10&mdash;看不懂的路由规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1zl19.html">ActiveMQ in Action&lpar;4&rpar; - Security</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1474mq.html">SQL2008实现数据库自动定时备份&mdash;&mdash;维护计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j00wo8.html">Mac下ssh连接远程服务器时自动断开问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2nke9.html">IOS学习［Swift中跳转与传值］</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jykjx8.html">OpenWRT （RT5350） 使能两个串口</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j12jx8.html">文件上传，服务端压缩文件方法，重点是png与gif图片的压缩，保证了透明度与动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy177edq.html">从零开始学习PYTHON3讲义（九）字典类型和插入排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdr3vy9.html">Qt class</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpm1k8.html">工作经验-Oracle定时数据备份</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2k3lgoq.html">js06</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k3l4xq.html">Excel中线性规划求解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v46gzq.html">mysql互为主从实战设置详解及自动化备份&lpar;Centos7&period;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v47z5q.html">剑指offer二十一之栈的压入、弹出序列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn7x74q.html">java数据结构之二叉树的定义和递归实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpg2ke9.html">Java虚拟机（七）：JVM调优案列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppg1dd9.html">玩转mongodb（一）：初识mongodb</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vyz62q.html">Ionic2开发环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpze6l9.html">MySQL 中 You can&amp;&num;39&semi;t specify target table &amp;&num;39&semi;表名&amp;&num;39&semi; for update in FROM clause错误解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p7jjjq.html">Hibernate中NoSession问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
